<template>
  <div>
      <v-card tile flat v-if="loading && roles === null" height="40">
          <div class="text-center">
              Fetching data ...
            <v-progress-circular indeterminate color="primary" :width="3" :size="32"></v-progress-circular>
          </div>
      </v-card>
      <v-card flat tile align="center" justify="center" v-if="!loading && roles === null">
            <v-card-text>
              No Roles found matching this criteria.
            </v-card-text>
      </v-card>
      <createRole  @stored="stored()"></createRole>

      <v-data-table
      :headers="headers"
      :items="roles"
      class="elevation-1 main-table px-2"
      hide-default-footer
      disable-pagination
      item-key="id"
      v-if="roles !== null"
      >
       <template v-slot:item.name="{ item }">
          {{ item.name.split('::').pop() }}
        </template>

        <template v-slot:item.description="{ item }">
          <v-tooltip
            right
            allow-overflow
            color="#333"
            max-width="250"
            v-if="item.description"
          >
            <template v-slot:activator="{ on, attrs }">
              <div
                class="text-truncate"
                style="width: 250px"
                v-bind="attrs"
                v-on="on"
              >
                {{ item.description || 'n/a' }}
              </div>
            </template>
            <span>{{ item.description }}</span>
          </v-tooltip>
          <span v-else>n/a</span>
        </template>

        <template v-slot:item.registered_at="{ item }">
          <span class=""> {{ getFormatedUTCTime(item.registered_at) }}</span>
        </template>
          <template v-slot:item.actions="{ item }">
          <v-btn
            text
            small
            color="primary"
            class="ttn caption light-primary no-transform"
            @click="role = item"
          >
            Edit
          </v-btn>
        </template>
      </v-data-table>

       <editRole
        :role="role"
        @updated="updated"
        @close="role = null"
       ></editRole>
  </div>
</template>

<script>
import { mapMutations, mapGetters, mapState, mapActions } from 'vuex';

export default {
  name: 'Roles',
  components: {
    createRole: () => import('./create'),
    editRole: () => import('./edit'),
  },

  data() {
    return {
      loading: false,
      page: 1,
      roles: null,
      role: null,
      headers: [
        {
          text: 'Role',
          align: 'start',
          sortable: false,
          value: 'display_name',
        },
        { text: 'Role ID', value: 'id' },
        { text: 'Name', value: 'name' },
        { text: 'Description', value: 'description', width: '300' },

        { text: 'Actions', value: 'actions' },

      ],
    };
  },

  async mounted() {
    await this.retrieveRoles();
  },
  methods: {
    ...mapActions(['requestEntityData']),

    async retrieveRoles() {
      this.loading = true;
      this.roles = null;
      // this.roles =  await this.roleObj.fetchPaginated(this.page);
      this.roles = [
        {
          id: 1,
          name: 'Doctors',
          description: 'Responsible for diagnosing and treating medical conditions.',
        },
        {
          id: 2,
          name: 'Facility owners',
          description: 'Owners or managers of medical facilities.',
        },
        {
          id: 3,
          name: 'Nurses',
          description: 'Provide patient care and support to doctors.',
        },
        {
          id: 4,
          name: 'Cashiers',
          description: 'Handle financial transactions in the medical facility.',
        },
        {
          id: 5,
          name: 'Pharmacists',
          description: 'Dispense medications and provide medication-related information to patients.',
        },
        {
          id: 6,
          name: 'Lab Technicians',
          description: 'Perform tests on patient samples to assist in diagnosis and treatment.',
        },
      ];
      this.loading = true;
    },

    stored() {
      this.retrieveRoles();
    },

    updated() {
      this.role = null;
      this.retrieveRoles();
    },
  },

};
</script>

<style>

</style>
